"""
 SControl.py: 
 ------------
 steuert den Prozess einer Suchanfrage, indem die einzelnen Komponenten 
 der Suchmaschine (FileReader, Parser und Analyzer) der Reihe nach aufgerufen werden.
"""

import DataFormat_Quelltext
import DataFormat_HTML_Content
import DataFormat_Treffer
import Task_Analyzer
import Task_FileReader
import Task_Parser
import os

"""
searchFile(File f):
-------------------
durchsucht eine HTML-Datei 'f' nach der Häufigkeit des Auftretens des 
Suchpatterns 'suchPattern' in den Abschnitten <title> und <body>.
Es werden Fehlermeldungen ausgegeben, wenn die Datei keine HTML-Datei ist, 
oder wenn Probleme beim Lesen der Datei auftraten.
"""

def searchFile(pfad, datei):

    """ Aufruf der Aufgabe von Team 1 """
    content = Task_FileReader.fileToString (pfad, datei)
        
    """ Schönheitskorrektur (siehe unten) """
    content.txt = haircut(content.txt)  
        
    # Wenn kein Fehler aufgetreten ist
    if (not content.fileError):   

        """ Aufruf der Aufgabe von Team 2 """
        html = Task_Parser.parsing(content.txt) 
            
        # Schönheitskorrektur (siehe unten)
        html.title = haircut(html.title)  
        html.body = haircut(html.body)
            
        # Wenn die Datei eine HTML-Datei ist
        istHTML = not html.keinHTML
        if (istHTML):

            """ Aufruf der Aufgabe von Team 3 """
            count = DataFormat_Treffer.Treffer()
            count = Task_Analyzer.analyze(html, suchPattern) 
               
            """ Ausgabe der Treffer: Ausgangspunkt für Aufgabe von Team 4 (optional) """
            print("Die Datei", datei, "enthält ...")
            print("...", count.titleMatches, "Übereinstimmungen im <title>")
            print("...", count.bodyMatches, "Übereinstimmungen im <body>")
            print()
               
            """ Fehlerbehandlung ... """
        
        # ... wenn die gelesene Datei keine HTML-Datei ist ...
        else:             
            print("ACHTUNG: Die Datei", datei, "ist keine HTML-Datei!")
            print()
    # ... wenn beim Lesen der Datei ein Fehler auftrat ...
    else:                  
        print("ACHTUNG: Beim Lesen der Datei", datei, "ist ein Fehler aufgetreten!")
        print()

    
"""
haircut(String s):
-------------------
Eine kleine Schönheitskorrektur für Zeichenketten:
Entfernt doppelte Leerzeichen sowie eventuell enthaltene Sonderzeichen
an Anfang und Ende des Strings.
"""

def haircut(s):
    txt = s.strip()
    while (txt.find("  ") > -1):
        txt = txt.replace("  ", " ") 
    return txt


"""
main-Routine
"""

# Initialisierung
eingabe = ""
suchPattern = ""
pfad = "C:\\Temp"       # Bitte hier den eigenen Standardpfad setzen (erleichtert das Entwickeln)

# Eingabe Such-Pfad 
print("Aktuelles Verzeichnis: ", pfad)
while (eingabe != "j") and (eingabe != "n"):
    print("Neues Verzeichnis [j/n]?")
    eingabe = input()
if (eingabe == "j"):
    isDir = False
    while (not isDir):
        print()
        print("Bitte geben Sie das zu durchsuchende Verzeichnis ein: ")
        pfad = input()
        istPfad = os.path.isdir(pfad)
        pfadExistiert = os.path.exists(pfad)
        if (not istPfad) or (not pfadExistiert):
            print("Kein gültiges Verzeichnis")

# Eingabe Suchbegriff
print()
print("Geben Sie den Suchstring ein: ")
while suchPattern == "" :
    suchPattern = input()

# Verarbeitung
if not (os.path.isdir(pfad) and os.path.exists(pfad)):
    print ("DEBUG-Message: Standardpfad ist kein Verzeichnis")
os.chdir(pfad)
folder = os.listdir(pfad)
print ("Es werden", len(folder), "Datei(en) durchsucht ...")
print ("Bitte haben Sie etwas Geduld ...")
print ()
folder.sort()
for dateiname in folder:
    searchFile (pfad, dateiname)
