program HTML_Suchmaschine;
{$APPTYPE CONSOLE}

uses
  sysutils,
  Hilfsfunktionen in 'Hilfsfunktionen.pas',
  AufgTeam1 in 'AufgTeam1.pas',
  AufgTeam2 in 'AufgTeam2.pas',
  AufgTeam3 in 'AufgTeam3.pas';

var
  CurrentFile : TFileContent;
  CurrentContent : THTMLContent;
  CurrentTreffer : TTreffer;
  Files : TStringArray;
  Directory, SearchPattern : string;
  index, matches : integer;

// Hauptprogramm
begin
  // Eingabe
  writeln ('HTML-Suchmaschine');
  writeln ('-----------------');
  writeln;
  write ('Bitte das zu dursuchende Directory eingeben: '); readln (Directory);
  write ('Bitte die zu suchende Zeichenkette eingeben: '); readln (SearchPattern);
  SearchPattern := AnsiLowerCase (SearchPattern); // Gro-Klein-Schreibung ignorieren

  // Initialisierung
  directory := IncludeTrailingBackslash (directory); // fehlenden Backslash ggf. an 'dir' anhngen
  CurrentFile := TFileContent.Create;
  CurrentContent := THTMLContent.Create;
  CurrentTreffer := TTreffer.Create;

  // Verarbeitung
  Files := DirectoryList (directory);  // Alle Dateinamen in 'Directory' einlesen;
  if length(Files) > 0 then begin
    for index := 0 to high (Files) do begin

      // Team 1: Files auslesen
      CurrentFile := FileToString(Directory, Files[index]);
      if CurrentFile.IOProblem = true then
         writeln ('Es kam zu Problemen beim Auslesen der Datei ', Files[index])
      else begin
        CurrentFile.txt := AnsiLowerCase (CurrentFile.txt); // Gro-Klein-Schreibung ignorieren

      // Team 2: Inhalt von Tags befreien
        CurrentContent := Parse (CurrentFile.txt);
      end; // end of else

      // Team 3: Anzahl der Treffer
      CurrentTreffer := CountMatches(CurrentContent, SearchPattern);

      // Ausgabe
      matches := CurrentTreffer.title + CurrentTreffer.body;
      if matches > 0 then    // wenn SearchPattern in der aktuellen Datei gefunden wurde ...
         writeln (matches, ' Treffer in ', Files[index], '  :  ', CurrentTreffer.title, ' im <title>, ',  CurrentTreffer.body, ' im <body>');

    end;  // Ende der Zhlschleife
    writeln ('Es wurden ', length (Files), ' Dateien durchsucht');
  end        // end of if
  else begin // wenn also 'Files' keine Eintrge hat
    writeln;
    writeln ('Achtung!');
    writeln ('Das Verzeichnis ', directory, ' enthaelt keine Dateien');
  end; // end of else

  // Finalisierung
  readln;
end.