unit Hilfsfunktionen;

interface

  Type
  // Rckgabetyp der Funktion 'DirectoryList'
  TStringArray = array of string;

  // *************************************************************************
  // DirectoryList: Gibt die Namen aller Dateien im Verzeichniss 'dir'
  // als 'TStringArray' (einem etwas anders benannten 'array of string') zurck
  // *************************************************************************
  function DirectoryList (dir: string): TStringArray;

  // *************************************************************************
  // DoubleSpaceRemove: entfernt alle doppelten Leerzeichen aus dem String 'S'
  // und gibt den gekrzten String zurck.
  // *************************************************************************
  function DoublespaceRemove (S : string) : String;

implementation

  uses
     sysutils;

// *************************************************************************
// DirectoryList: Gibt die Namen aller Dateien im Verzeichniss 'dir'
// in einem TStringArray (einem etwas anders benannten 'array of string') zurck
// *************************************************************************
function DirectoryList (dir: string): TStringArray;
var
  SR: TSearchRec;
  newLength : Integer;
  FileList: TStringArray;
begin
  dir := IncludeTrailingBackslash (dir);                          // fehlenden Backslash ggf. an 'dir' anhngen
  newLength := 1;
  if FindFirst(dir + '*.*', faAnyFile, SR) = 0 then begin         // wenn File im Verzeichnis ...
    repeat
      if (SR.Name <> '.') and (SR.Name <> '..') and (SR.Attr AND faDirectory = 0) then begin    // wenn das Gefundene kein (Unter-)Verzeichnis ist ...
        SetLength(FileList, newLength);              // Array um 1 vergrern
        FileList[High(FileList)] := SR.Name;         // Dateinamen in Array schreiben
        newLength := newLength + 1;
      end;
    until FindNext(SR) <> 0;                         // Abbruch, wenn alle Elemente im Verzeichnis durchsucht wurden.
  end;
  result := FileList;
end;

// *************************************************************************
// DoubleSpaceRemove: entfernt alle doppelten Leerzeichen aus einem String S
// und gibt den gekrzten String zurck.
// *************************************************************************

function DoublespaceRemove (S : string) : String;
begin
  result := S;
  while Pos ('  ', result) <> 0 do begin                         // solange ein doppeltes Leerzeichen existiert ...
    Result := StringReplace (Result, '  ', ' ', [rfReplaceAll]); // ... doppeltes Leerzeichen durch ein einfaches ersetzen
  end;
  Result := Trim (Result);                                       // Leer- und Steuerzeichen am Anfang und Ende abschneiden
end;

end.
 